import{s as As,n as Ss,o as qs}from"../chunks/scheduler.9bc65507.js";import{S as Rs,i as Us,g as r,s as m,r as T,m as c,H as d,A as Gs,h,f as t,c as p,j as fs,u as C,x as L,n as o,B as u,k as us,y as i,a as l,v as P,d as j,t as A,w as S}from"../chunks/index.707bf1b6.js";import{H as q}from"../chunks/Heading.342b1fa6.js";function Ks(ws){let g,R,E,U,f,G,w,xs=`ほとんどのTransformerモデルは、アテンション行列が正方形であるという意味で完全なアテンションを使用します。
これは、長いテキストを扱う場合に計算のボトルネックとなることがあります。LongformerやReformerは、より効率的でトレーニングを高速化するためにアテンション行列のスパースバージョンを使用しようとするモデルです。`,K,x,O,y,ys=`<a href="model_doc/reformer">Reformer</a>はLSH（局所的に散在ハッシュ）アテンションを使用します。
ソフトマックス(QK^t)では、行列QK^tの中で（ソフトマックス次元で）最も大きな要素のみが有用な寄与を提供します。
したがって、各クエリqについて、クエリqに近いキーkのみを考慮できます。
qとkが近いかどうかを決定するために、ハッシュ関数が使用されます。
アテンションマスクは変更され、現在のトークンをマスク化します（最初の位置を除く）。
なぜなら、それはクエリとキーが等しい（つまり非常に似ている）クエリとキーを提供するからです。
ハッシュは多少ランダムかもしれないため、実際にはいくつかのハッシュ関数が使用され（n_roundsパラメータで決定されます）、それらが平均化されます。`,Q,_,B,b,_s=`<a href="model_doc/longformer">Longformer</a>はローカルアテンションを使用します。
しばしば、ローカルコンテキスト（例：左右の2つのトークンは何ですか？）は、特定のトークンに対して行動を起こすのに十分です。
また、小さなウィンドウを持つアテンションレイヤーを積み重ねることで、最後のレイヤーはウィンドウ内のトークンだけでなく、ウィンドウ内のトークンを超えて受容野を持つようになり、文全体の表現を構築できます。`,D,$,bs=`一部の事前選択された入力トークンにはグローバルアテンションも与えられます。
これらの少数のトークンに対して、アテンション行列はすべてのトークンにアクセスでき、このプロセスは対称的です。
他のすべてのトークンは、これらの特定のトークンにアクセスできます（ローカルウィンドウ内のトークンに加えて）。
これは、論文の図2dに示されており、以下はサンプルのアテンションマスクです：`,I,v,$s='<img scale="50 %" align="center" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/local_attention_mask.png"/>',V,k,F,M,J,n,z,ks="Reformer",vs,N,Ms='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>l</mi></mrow><annotation encoding="application/x-tex">l</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span></span></span></span>',W,X,zs='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>d</mi></mrow><annotation encoding="application/x-tex">d</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal">d</span></span></span></span>',Y,Z,Ls='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>l</mi><mn>1</mn></msub><mo>×</mo><msub><mi>d</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">l_{1} \\times d_{1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0197em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">×</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">d</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ss,as,Es='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>l</mi><mn>2</mn></msub><mo>×</mo><msub><mi>d</mi><mn>2</mn></msub></mrow><annotation encoding="application/x-tex">l_{2} \\times d_{2}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0197em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">×</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">d</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ts,ns,Hs='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>l</mi><mn>1</mn></msub><mo>×</mo><msub><mi>l</mi><mn>2</mn></msub><mo>=</mo><mi>l</mi></mrow><annotation encoding="application/x-tex">l_{1} \\times l_{2} = l</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0197em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">×</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0197em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span></span></span></span>',es,ls,Ts='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>d</mi><mn>1</mn></msub><mo>+</mo><msub><mi>d</mi><mn>2</mn></msub><mo>=</mo><mi>d</mi></mrow><annotation encoding="application/x-tex">d_{1} + d_{2} = d</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">d</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">d</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal">d</span></span></span></span>',ms,ps,Cs='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>j</mi></mrow><annotation encoding="application/x-tex">j</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.854em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05724em;">j</span></span></span></span>',is,rs,Ps='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>j</mi><mi mathvariant="normal">%</mi><mi>l</mi><mn>1</mn></mrow><annotation encoding="application/x-tex">j \\% l1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.9444em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05724em;">j</span><span class="mord">%</span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord">1</span></span></span></span>',cs,hs,js='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>j</mi><mi mathvariant="normal">/</mi><mi mathvariant="normal">/</mi><mi>l</mi><mn>1</mn></mrow><annotation encoding="application/x-tex">j // l1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.05724em;">j</span><span class="mord">//</span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord">1</span></span></span></span>',os,gs,H,ds;return f=new q({props:{title:"Attention mechanism",local:"attention-mechanism",headingTag:"h1"}}),x=new q({props:{title:"LSH attention",local:"lsh-attention",headingTag:"h2"}}),_=new q({props:{title:"Local attention",local:"local-attention",headingTag:"h2"}}),k=new q({props:{title:"Other tricks",local:"other-tricks",headingTag:"h2"}}),M=new q({props:{title:"Axial positional encodings",local:"axial-positional-encodings",headingTag:"h3"}}),{c(){g=r("meta"),R=m(),E=r("p"),U=m(),T(f.$$.fragment),G=m(),w=r("p"),w.textContent=xs,K=m(),T(x.$$.fragment),O=m(),y=r("p"),y.innerHTML=ys,Q=m(),T(_.$$.fragment),B=m(),b=r("p"),b.innerHTML=_s,D=m(),$=r("p"),$.textContent=bs,I=m(),v=r("div"),v.innerHTML=$s,V=m(),T(k.$$.fragment),F=m(),T(M.$$.fragment),J=m(),n=r("p"),z=r("a"),z.textContent=ks,vs=c("は軸方向の位置エンコーディングを使用しています。伝統的なトランスフォーマーモデルでは、位置エンコーディングEはサイズが"),N=new d(!1),W=c(" ×"),X=new d(!1),Y=c(" の行列で、\\(l\\) はシーケンスの長さ、\\(d\\) は隠れ状態の次元です。非常に長いテキストを扱う場合、この行列は非常に大きく、GPU上で大量のスペースを占有します。これを緩和するために、軸方向の位置エンコーディングは、この大きな行列Eを2つの小さな行列E1とE2に分解します。それぞれの行列はサイズ"),Z=new d(!1),ss=c(" および"),as=new d(!1),ts=c(" を持ち、"),ns=new d(!1),es=c(" および"),ls=new d(!1),ms=c(" という条件を満たします（長さの積を考えると、これがはるかに小さくなります）。行列E内の時刻"),ps=new d(!1),is=c(" の埋め込みは、E1内の時刻"),rs=new d(!1),cs=c(" の埋め込みとE2内の時刻"),hs=new d(!1),os=c(" の埋め込みを連結することによって得られます。"),gs=m(),H=r("p"),this.h()},l(s){const a=Gs("svelte-u9bgzb",document.head);g=h(a,"META",{name:!0,content:!0}),a.forEach(t),R=p(s),E=h(s,"P",{}),fs(E).forEach(t),U=p(s),C(f.$$.fragment,s),G=p(s),w=h(s,"P",{"data-svelte-h":!0}),L(w)!=="svelte-178456v"&&(w.textContent=xs),K=p(s),C(x.$$.fragment,s),O=p(s),y=h(s,"P",{"data-svelte-h":!0}),L(y)!=="svelte-1txl2rb"&&(y.innerHTML=ys),Q=p(s),C(_.$$.fragment,s),B=p(s),b=h(s,"P",{"data-svelte-h":!0}),L(b)!=="svelte-1z0h79f"&&(b.innerHTML=_s),D=p(s),$=h(s,"P",{"data-svelte-h":!0}),L($)!=="svelte-146lctt"&&($.textContent=bs),I=p(s),v=h(s,"DIV",{class:!0,"data-svelte-h":!0}),L(v)!=="svelte-d4kpls"&&(v.innerHTML=$s),V=p(s),C(k.$$.fragment,s),F=p(s),C(M.$$.fragment,s),J=p(s),n=h(s,"P",{});var e=fs(n);z=h(e,"A",{href:!0,"data-svelte-h":!0}),L(z)!=="svelte-zf8r8v"&&(z.textContent=ks),vs=o(e,"は軸方向の位置エンコーディングを使用しています。伝統的なトランスフォーマーモデルでは、位置エンコーディングEはサイズが"),N=u(e,!1),W=o(e," ×"),X=u(e,!1),Y=o(e," の行列で、\\(l\\) はシーケンスの長さ、\\(d\\) は隠れ状態の次元です。非常に長いテキストを扱う場合、この行列は非常に大きく、GPU上で大量のスペースを占有します。これを緩和するために、軸方向の位置エンコーディングは、この大きな行列Eを2つの小さな行列E1とE2に分解します。それぞれの行列はサイズ"),Z=u(e,!1),ss=o(e," および"),as=u(e,!1),ts=o(e," を持ち、"),ns=u(e,!1),es=o(e," および"),ls=u(e,!1),ms=o(e," という条件を満たします（長さの積を考えると、これがはるかに小さくなります）。行列E内の時刻"),ps=u(e,!1),is=o(e," の埋め込みは、E1内の時刻"),rs=u(e,!1),cs=o(e," の埋め込みとE2内の時刻"),hs=u(e,!1),os=o(e," の埋め込みを連結することによって得られます。"),e.forEach(t),gs=p(s),H=h(s,"P",{}),fs(H).forEach(t),this.h()},h(){us(g,"name","hf:doc:metadata"),us(g,"content",Os),us(v,"class","flex justify-center"),us(z,"href","model_doc/reformer"),N.a=W,X.a=Y,Z.a=ss,as.a=ts,ns.a=es,ls.a=ms,ps.a=is,rs.a=cs,hs.a=os},m(s,a){i(document.head,g),l(s,R,a),l(s,E,a),l(s,U,a),P(f,s,a),l(s,G,a),l(s,w,a),l(s,K,a),P(x,s,a),l(s,O,a),l(s,y,a),l(s,Q,a),P(_,s,a),l(s,B,a),l(s,b,a),l(s,D,a),l(s,$,a),l(s,I,a),l(s,v,a),l(s,V,a),P(k,s,a),l(s,F,a),P(M,s,a),l(s,J,a),l(s,n,a),i(n,z),i(n,vs),N.m(Ms,n),i(n,W),X.m(zs,n),i(n,Y),Z.m(Ls,n),i(n,ss),as.m(Es,n),i(n,ts),ns.m(Hs,n),i(n,es),ls.m(Ts,n),i(n,ms),ps.m(Cs,n),i(n,is),rs.m(Ps,n),i(n,cs),hs.m(js,n),i(n,os),l(s,gs,a),l(s,H,a),ds=!0},p:Ss,i(s){ds||(j(f.$$.fragment,s),j(x.$$.fragment,s),j(_.$$.fragment,s),j(k.$$.fragment,s),j(M.$$.fragment,s),ds=!0)},o(s){A(f.$$.fragment,s),A(x.$$.fragment,s),A(_.$$.fragment,s),A(k.$$.fragment,s),A(M.$$.fragment,s),ds=!1},d(s){s&&(t(R),t(E),t(U),t(G),t(w),t(K),t(O),t(y),t(Q),t(B),t(b),t(D),t($),t(I),t(v),t(V),t(F),t(J),t(n),t(gs),t(H)),t(g),S(f,s),S(x,s),S(_,s),S(k,s),S(M,s)}}}const Os='{"title":"Attention mechanism","local":"attention-mechanism","sections":[{"title":"LSH attention","local":"lsh-attention","sections":[],"depth":2},{"title":"Local attention","local":"local-attention","sections":[],"depth":2},{"title":"Other tricks","local":"other-tricks","sections":[{"title":"Axial positional encodings","local":"axial-positional-encodings","sections":[],"depth":3}],"depth":2}],"depth":1}';function Qs(ws){return qs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vs extends Rs{constructor(g){super(),Us(this,g,Qs,Ks,As,{})}}export{Vs as component};
